<?php

namespace App\ApiResource;

use ApiPlatform\Metadata\ApiFilter;
use ApiPlatform\Metadata\ApiProperty;
use ApiPlatform\Metadata\ApiResource;
use ApiPlatform\Metadata\Delete;
use ApiPlatform\Metadata\Get;
use ApiPlatform\Metadata\GetCollection;
use ApiPlatform\Metadata\Patch;
use ApiPlatform\Metadata\Post;
use ApiPlatform\Doctrine\Orm\State\Options;
use App\Entity\Location;
use App\Filter\CustomJsonFilter;
use App\Filter\CustomJsonOrderFilter;
use App\Filter\LocationNameCodeSearchFilter;
use App\State\EntityClassDtoStateProcessor;
use App\State\EntityToDtoStateProvider;
use Symfony\Component\Validator\Constraints as Assert;
use Symfony\Component\PropertyInfo\Type;
use Symfony\Component\Validator\Constraints\NotBlank;

#[ApiResource(
    shortName: 'Location',
    operations: [
        new Get(
            security: 'is_granted("ROLE_USER")'
        ),
        new GetCollection(
            security: 'is_granted("ROLE_USER")'
        ),
        new Post(
            security: 'is_granted("ROLE_ADMIN")'
        ),
        new Patch(
            security: 'is_granted("ROLE_ADMIN")'
        ),
        new Delete(
            security: 'is_granted("ROLE_ADMIN")'
        )
    ],
    security: 'is_granted("ROLE_USER")',
    provider: EntityToDtoStateProvider::class,
    processor: EntityClassDtoStateProcessor::class,
    stateOptions: new Options(entityClass: Location::class),
)]
#[ApiFilter(LocationNameCodeSearchFilter::class, properties: [
    'name' => 'ipartial',
    'code' => 'ipartial',
])]
#[ApiFilter(CustomJsonFilter::class)]
#[ApiFilter(CustomJsonOrderFilter::class)]
class LocationApi
{
    #[ApiProperty(readable: false, writable: false, identifier: true)]
    public ?int $id = null;

    #[ApiProperty(writable: false)]
    public ?int $dbId = null;

    /**
     * @var ZoneApi
     */
    #[ApiProperty(
        writable: false,
        readableLink: true,
        writableLink: false,
        builtinTypes: [
            new Type(
                'object',
                class: ZoneApi::class,
            )
        ]
    )]
    public ?ZoneApi $zone = null;

    #[NotBlank]
    #[ApiProperty(writable: true)]
    public ?ZoneApi $zoneIri = null;

    #[Assert\NotBlank]
    public string $name;

    #[Assert\NotBlank]
    public string $code;

    #[ApiProperty(writable: false)]
    public string $zoneName;

    public bool $isZone;

    public bool $isPlace;

    public bool $isPort;

    public bool $isStartEnd;

    #[ApiProperty(writable: false)]
    public ?\DateTimeImmutable $createdAt = null;
}